package demo ;

import java.awt.Point ;
import java.awt.event.MouseAdapter ;
import java.awt.event.MouseEvent ;
import java.util.Enumeration ;

import javax.swing.JPanel ;
import javax.swing.JTree ;
import javax.swing.tree.DefaultMutableTreeNode ;
import javax.swing.tree.TreePath ;

import demo.areacharts.AreaChartDemo1 ;
import demo.areacharts.StackedAreaChartDemo1 ;
import demo.areacharts.StackedXYAreaChartDemo1 ;
import demo.areacharts.StackedXYAreaChartDemo2 ;
import demo.areacharts.XYAreaChartDemo1 ;
import demo.areacharts.XYAreaChartDemo2 ;
import demo.areacharts.XYAreaRenderer2Demo1 ;
import demo.areacharts.XYStepAreaRendererDemo1 ;
import demo.barcharts.category.BarChart3DDemo1 ;
import demo.barcharts.category.BarChart3DDemo2 ;
import demo.barcharts.category.BarChart3DDemo3 ;
import demo.barcharts.category.BarChart3DDemo4 ;
import demo.barcharts.category.BarChartDemo1 ;
import demo.barcharts.category.BarChartDemo10 ;
import demo.barcharts.category.BarChartDemo11 ;
import demo.barcharts.category.BarChartDemo2 ;
import demo.barcharts.category.BarChartDemo3 ;
import demo.barcharts.category.BarChartDemo4 ;
import demo.barcharts.category.BarChartDemo5 ;
import demo.barcharts.category.BarChartDemo6 ;
import demo.barcharts.category.BarChartDemo7 ;
import demo.barcharts.category.BarChartDemo8 ;
import demo.barcharts.category.BarChartDemo9 ;
import demo.barcharts.category.CylinderChartDemo1 ;
import demo.barcharts.category.CylinderChartDemo2 ;
import demo.barcharts.category.IntervalBarChartDemo1 ;
import demo.barcharts.category.LayeredBarChartDemo1 ;
import demo.barcharts.category.LayeredBarChartDemo2 ;
import demo.barcharts.category.SlidingCategoryDatasetDemo1 ;
import demo.barcharts.category.SlidingCategoryDatasetDemo2 ;
import demo.barcharts.category.StatisticalBarChartDemo1 ;
import demo.barcharts.category.SurveyResultsDemo1 ;
import demo.barcharts.category.SurveyResultsDemo2 ;
import demo.barcharts.category.SurveyResultsDemo3 ;
import demo.barcharts.category.WaterfallChartDemo1 ;
import demo.barcharts.xy.ClusteredXYBarRendererDemo1 ;
import demo.barcharts.xy.RelativeDateFormatDemo2 ;
import demo.barcharts.xy.StackedBarChartDemo4 ;
import demo.barcharts.xy.StackedXYBarChartDemo1 ;
import demo.barcharts.xy.StackedXYBarChartDemo2 ;
import demo.barcharts.xy.StackedXYBarChartDemo3 ;
import demo.barcharts.xy.XYBarChartDemo1 ;
import demo.barcharts.xy.XYBarChartDemo2 ;
import demo.barcharts.xy.XYBarChartDemo3 ;
import demo.barcharts.xy.XYBarChartDemo4 ;
import demo.barcharts.xy.XYBarChartDemo5 ;
import demo.barcharts.xy.XYBarChartDemo6 ;
import demo.barcharts.xy.XYBarChartDemo7 ;
import demo.combinecharts.CombinedCategoryPlotDemo1 ;
import demo.combinecharts.CombinedCategoryPlotDemo2 ;
import demo.combinecharts.CombinedTimeSeriesDemo1 ;
import demo.combinecharts.CombinedXYPlotDemo1 ;
import demo.combinecharts.CombinedXYPlotDemo2 ;
import demo.combinecharts.CombinedXYPlotDemo3 ;
import demo.combinecharts.CombinedXYPlotDemo4 ;
import demo.financialcharts.CandlestickChartDemo1 ;
import demo.financialcharts.HighLowChartDemo1 ;
import demo.financialcharts.HighLowChartDemo2 ;
import demo.financialcharts.HighLowChartDemo3 ;
import demo.financialcharts.MovingAverageDemo1 ;
import demo.financialcharts.PriceVolumeDemo1 ;
import demo.financialcharts.PriceVolumeDemo2 ;
import demo.granttcharts.GanttDemo1 ;
import demo.granttcharts.GanttDemo2 ;
import demo.granttcharts.SlidingGanttDatasetDemo1 ;
import demo.granttcharts.XYTaskDatasetDemo1 ;
import demo.granttcharts.XYTaskDatasetDemo2 ;
import demo.linecharts.AnnotationDemo1 ;
import demo.linecharts.LineChart3DDemo1 ;
import demo.linecharts.LineChartDemo1 ;
import demo.linecharts.LineChartDemo2 ;
import demo.linecharts.LineChartDemo3 ;
import demo.linecharts.LineChartDemo4 ;
import demo.linecharts.LineChartDemo5 ;
import demo.linecharts.LineChartDemo6 ;
import demo.linecharts.LineChartDemo7 ;
import demo.linecharts.LineChartDemo8 ;
import demo.linecharts.StatisticalLineChartDemo1 ;
import demo.linecharts.XYSplineRendererDemo1 ;
import demo.linecharts.XYStepRendererDemo1 ;
import demo.linecharts.XYStepRendererDemo2 ;
import demo.miscellaneous.AxisOffsetsDemo1 ;
import demo.miscellaneous.BubbleChartDemo1 ;
import demo.miscellaneous.BubbleChartDemo2 ;
import demo.miscellaneous.CategoryLabelPositionsDemo1 ;
import demo.miscellaneous.CategoryStepChartDemo1 ;
import demo.miscellaneous.CompassFormatDemo1 ;
import demo.miscellaneous.EventFrequencyDemo1 ;
import demo.miscellaneous.GradientPaintTransformerDemo1 ;
import demo.miscellaneous.GridBandDemo1 ;
import demo.miscellaneous.HideSeriesDemo1 ;
import demo.miscellaneous.HideSeriesDemo2 ;
import demo.miscellaneous.HideSeriesDemo3 ;
import demo.miscellaneous.MultipleDatasetDemo1 ;
import demo.miscellaneous.PolarChartDemo1 ;
import demo.miscellaneous.SpiderWebChartDemo1 ;
import demo.miscellaneous.SymbolAxisDemo1 ;
import demo.miscellaneous.ThumbnailDemo1 ;
import demo.miscellaneous.TranslateDemo1 ;
//import demo.others.GranttChartPanel1 ;
//import demo.others.Line3DChartPanel1 ;
//import demo.others.Pie3DChartPanel1 ;
//import demo.others.Pie3DChartPanel2 ;
//import demo.others.PieChartPanel3 ;
//import demo.others.PriceVolumeChartPanel1 ;
//import demo.others.RingChartPanel2 ;
//import demo.others.RingChartPanel3 ;
//import demo.others.StatisticalLineChartPanel1 ;
//import demo.others.StockChartPanel2 ;
//import demo.others.annotationcharts.CategoryAndPointerAnnotationTest1 ;
//import demo.others.annotationcharts.CategoryAndPointerAnnotationTest2 ;
//import demo.others.annotationcharts.CategoryLineAnnotationTest1 ;
//import demo.others.annotationcharts.CategoryLineAnnotationTest2 ;
//import demo.others.annotationcharts.CategoryTextAnnotationTest1 ;
//import demo.others.annotationcharts.CategoryTextAnnotationTest2 ;
//import demo.others.annotationcharts.CategoryTextAnnotationTestGroup1 ;
//import demo.others.annotationcharts.CategoryTextAnnotationTestGroup2 ;
//import demo.others.annotationcharts.XYImageAnnotationTest1 ;
//import demo.others.annotationcharts.XYImageAnnotationTest2 ;
//import demo.others.annotationcharts.XYLineAnnotationTest1 ;
//import demo.others.annotationcharts.XYLineAnnotationTest2 ;
//import demo.others.annotationcharts.XYPointerAnnotationTest1 ;
//import demo.others.annotationcharts.XYPointerAnnotationTest2 ;
//import demo.others.annotationcharts.XYPolygonAnnotationTest1 ;
//import demo.others.annotationcharts.XYPolygonAnnotationTest2 ;
//import demo.others.annotationcharts.XYShapeAnnotationTest1 ;
//import demo.others.annotationcharts.XYShapeAnnotationTest2 ;
//import demo.others.annotationcharts.XYTextAnnotationTest1 ;
//import demo.others.annotationcharts.XYTextAnnotationTest2 ;
//import demo.others.axis.CategoryAxis3DPanel ;
//import demo.others.axis.CategoryAxisPanel ;
//import demo.others.axis.MultipleAxisPanel ;
//import demo.others.axis.NumberValueAxisPanel ;
//import demo.others.categorycharts.AreaChartPanel1 ;
//import demo.others.categorycharts.AreaChartPanel2 ;
//import demo.others.categorycharts.BoxAndWhiskerChartPanel1 ;
//import demo.others.categorycharts.CategoryBar2DChartPanel1 ;
//import demo.others.categorycharts.CategoryBar2DChartPanel2 ;
//import demo.others.categorycharts.CategoryBar2DChartPanel3 ;
//import demo.others.categorycharts.CategoryBar3DChartPanel1 ;
//import demo.others.categorycharts.CategoryBar3DChartPanel2 ;
//import demo.others.categorycharts.CategoryLineAndShapeChartPanel1 ;
//import demo.others.categorycharts.CategoryLineAndShapeChartPanel2 ;
//import demo.others.categorycharts.CategoryLineAndShapeChartPanel4 ;
//import demo.others.categorycharts.CategoryStepChartPanel1 ;
//import demo.others.categorycharts.CylinderChartPanel ;
//import demo.others.categorycharts.GranttChartPanel2 ;
//import demo.others.categorycharts.GranttChartPanel3 ;
//import demo.others.categorycharts.GranttChartPanel4 ;
//import demo.others.categorycharts.GranttChartPanel5 ;
//import demo.others.categorycharts.GranttChartPanel6 ;
//import demo.others.categorycharts.GranttChartPanel7 ;
//import demo.others.categorycharts.GranttChartPanel8 ;
//import demo.others.categorycharts.GroupStackedBarChartPanel1 ;
//import demo.others.categorycharts.GroupStackedBarChartPanel2 ;
//import demo.others.categorycharts.GroupStackedBarChartPanel3 ;
//import demo.others.categorycharts.GroupStackedBarChartPanel4 ;
//import demo.others.categorycharts.IntervalBarChartPanel ;
//import demo.others.categorycharts.LayeredBarChartPanel ;
//import demo.others.categorycharts.LevelChartPanel1 ;
//import demo.others.categorycharts.LevelChartPanel2 ;
//import demo.others.categorycharts.OverlaidBarChartpPanel1 ;
//import demo.others.categorycharts.StackedBarChartPanel1 ;
//import demo.others.categorycharts.StackedBarChartPanel2 ;
//import demo.others.categorycharts.StatisticalBarChartPanel1 ;
//import demo.others.categorycharts.StatisticalBarChartPanel2 ;
//import demo.others.categorycharts.StatisticalBarChartPanel3 ;
//import demo.others.categorycharts.StatisticalBarChartPanel4 ;
//import demo.others.categorycharts.StatisticalBarChartPanel5 ;
//import demo.others.categorycharts.StatisticalBarChartPanelWithLabel ;
//import demo.others.categorycharts.StatisticalLineChartPanelWithLabelPanel ;
//import demo.others.categorycharts.SymbolCategoryLineAndShapeChartPanel1 ;
//import demo.others.categorycharts.SymbolCategoryLineAndShapeChartPanel2 ;
//import demo.others.categorycharts.SymbolCategoryLineAndShapeChartPanel3 ;
//import demo.others.categorycharts.SymbolCategoryLineAndShapeChartPanel4 ;
//import demo.others.categorycharts.SymbolXYLineAndShapeChartPanel1 ;
//import demo.others.categorycharts.SymbolXYLineAndShapeChartPanel2 ;
//import demo.others.categorycharts.SymbolXYLineAndShapeChartPanel3 ;
//import demo.others.categorycharts.SymbolXYLineAndShapeChartPanel4 ;
//import demo.others.categorycharts.WaterfallBarChartPanel1 ;
//import demo.others.categorycharts.WaterfallBarChartPanel2 ;
//import demo.others.categorycharts.WaterfallBarChartPanel3 ;
//import demo.others.categorycharts.WaterfallBarChartPanel4 ;
//import demo.others.financialcharts.YieldCurveChartPanel__NotImplemented ;
//import demo.others.metercharts.MeterChartPanel1 ;
//import demo.others.metercharts.MeterChartPanel2 ;
//import demo.others.metercharts.MeterChartPanel3 ;
//import demo.others.metercharts.MeterChartPanel4 ;
//import demo.others.metercharts.MeterChartPanel5 ;
//import demo.others.shapes.ArcShapeTestPanel ;
//import demo.others.shapes.BoxAndWhiskerChartShapePanel ;
//import demo.others.shapes.CylinderTextChartShapePanel ;
//import demo.others.shapes.DblHeadMatchstickChartShapePanel ;
//import demo.others.shapes.DualBreakLineChartShapePanel ;
//import demo.others.shapes.EllipseTextChartShapePanel ;
//import demo.others.shapes.ErrorCrossChartShapePanel ;
//import demo.others.shapes.GeneralPathChartShapePanel ;
//import demo.others.shapes.GranttChartShapePanel ;
//import demo.others.shapes.HighLowChartShapePanel ;
//import demo.others.shapes.IShapedChartShapePanel ;
//import demo.others.shapes.LineAndShapeChartShapePanel ;
//import demo.others.shapes.LineChartShapePanel ;
//import demo.others.shapes.LineToRectanglePanel ;
//import demo.others.shapes.MeterArcShapePanel ;
//import demo.others.shapes.MinMaxChartShapePanel ;
//import demo.others.shapes.PaintScaleLegendShapePanel ;
//import demo.others.shapes.ParallelepipedChartShapePanel ;
//import demo.others.shapes.PathAppendPanel ;
//import demo.others.shapes.PieOutsideLabelChartShapePanel ;
//import demo.others.shapes.RectangleImageChartShapePanel ;
//import demo.others.shapes.RectangleTextChartShapePanel1 ;
//import demo.others.shapes.RectangleTextChartShapePanel2 ;
//import demo.others.shapes.RectangleTextChartShapePanel3 ;
//import demo.others.shapes.RingChartShapePanel ;
//import demo.others.shapes.Sector3DChartShapePanel ;
//import demo.others.shapes.SectorChartShapePanel ;
//import demo.others.shapes.StatisticalBarChartShapePanel ;
//import demo.others.shapes.StatisticalLineChartShapePanel ;
//import demo.others.shapes.StockChartShapePanel ;
//import demo.others.shapes.TextAndPointChartShapePanel ;
//import demo.others.shapes.TooltipShapeTestPanel ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel1 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel2 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel3 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel4 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel5 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel6 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel7 ;
//import demo.others.stackareacharts.StackedXYAreaChartPanel8 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel1 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel2 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel3 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel4 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel5 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel6 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel7 ;
//import demo.others.stackareacharts.StackedXYBarChartPanel8 ;
//import demo.others.stackareacharts.StackedXYStepAreaChartPanel1 ;
//import demo.others.stackareacharts.StackedXYStepAreaChartPanel2 ;
//import demo.others.stackareacharts.StackedXYStepAreaChartPanel3 ;
//import demo.others.stackareacharts.StackedXYStepAreaChartPanel4 ;
//import demo.others.stackareacharts.StackedXYStepAreaChartPanel5 ;
//import demo.others.stackareacharts.XYAreaChartPanel1 ;
//import demo.others.stackareacharts.XYAreaChartPanel2 ;
//import demo.others.xy.ClusteredXYNumberBar2DChartPanel1 ;
//import demo.others.xy.ClusteredXYNumberBar2DChartPanel2 ;
//import demo.others.xy.GrowthHorizontalChart ;
//import demo.others.xy.GrowthVerticalChart ;
//import demo.others.xy.HistogramChartPanel3 ;
//import demo.others.xy.IntervalXNumberBar2DChartPanelDay ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanel1 ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanel2 ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanelDay ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanelHour ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanelMinute ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanelMonth ;
//import demo.others.xy.IntervalXNumberYBaseBar2DChartPanelYear ;
//import demo.others.xy.IntervalXYNumberBar2DChartPanel1 ;
//import demo.others.xy.IntervalXYNumberBar2DChartPanel2 ;
//import demo.others.xy.XYBlockChartPanel1 ;
//import demo.others.xy.XYBlockChartPanel2 ;
//import demo.others.xy.XYBlockChartPanel3 ;
//import demo.others.xy.XYErrorChartPanel3 ;
//import demo.others.xy.XYLineAndShapeChartPanel1 ;
//import demo.others.xy.XYLineAndShapeChartPanel2 ;
//import demo.others.xy.XYLineAndShapeChartPanel3 ;
//import demo.others.xy.XYLineAndShapeChartPanel4 ;
//import demo.others.xy.XYLineAndShapeChartPanel5 ;
//import demo.others.xy.XYLineAndShapeChartPanel6 ;
//import demo.others.xy.XYStepLineChartPanel1 ;
//import demo.others.xy.XYStepLineChartPanel2 ;
//import demo.others.xycharts.DotDemo1 ;
//import demo.others.xycharts.DotDemo2 ;
//import demo.others.xycharts.ScatterDemo1 ;
import demo.miscellaneous.WindChartDemo1 ;
import demo.miscellaneous.YIntervalChartDemo1 ;
import demo.miscellaneous.YIntervalChartDemo2 ;
import demo.miscellaneous.annotations.AnnotationDemo2 ;
import demo.miscellaneous.annotations.CategoryPointerAnnotationDemo1 ;
import demo.miscellaneous.annotations.XYBoxAnnotationDemo1 ;
import demo.miscellaneous.annotations.XYPolygonAnnotationDemo1 ;
import demo.miscellaneous.annotations.XYTitleAnnotationDemo1 ;
import demo.miscellaneous.crosshairs.CrosshairDemo1 ;
import demo.miscellaneous.crosshairs.CrosshairDemo2 ;
import demo.miscellaneous.crosshairs.CrosshairDemo3 ;
import demo.miscellaneous.crosshairs.CrosshairDemo4 ;
import demo.miscellaneous.dynamiccharts.DynamicDataDemo1 ;
import demo.miscellaneous.dynamiccharts.DynamicDataDemo2 ;
import demo.miscellaneous.dynamiccharts.DynamicDataDemo3 ;
import demo.miscellaneous.dynamiccharts.MouseOverDemo1 ;
import demo.miscellaneous.itemlabel.ItemLabelDemo1 ;
import demo.miscellaneous.itemlabel.ItemLabelDemo2 ;
import demo.miscellaneous.itemlabel.ItemLabelDemo3 ;
import demo.miscellaneous.itemlabel.ItemLabelDemo4 ;
import demo.miscellaneous.itemlabel.ItemLabelDemo5 ;
import demo.miscellaneous.legends.LegendWrapperDemo1 ;
import demo.miscellaneous.markers.CategoryMarkerDemo1 ;
import demo.miscellaneous.markers.CategoryMarkerDemo2 ;
import demo.miscellaneous.markers.MarkerDemo1 ;
import demo.miscellaneous.markers.MarkerDemo2 ;
import demo.miscellaneous.orientation.PlotOrientationDemo1 ;
import demo.miscellaneous.orientation.PlotOrientationDemo2 ;
import demo.multipleaxischarts.DualAxisDemo1 ;
import demo.multipleaxischarts.DualAxisDemo2 ;
import demo.multipleaxischarts.DualAxisDemo3 ;
import demo.multipleaxischarts.DualAxisDemo4 ;
import demo.multipleaxischarts.DualAxisDemo5 ;
import demo.multipleaxischarts.MultipleAxisDemo1 ;
import demo.multipleaxischarts.MultipleAxisDemo2 ;
import demo.multipleaxischarts.MultipleAxisDemo3 ;
import demo.multipleaxischarts.ParetoChartDemo1 ;
import demo.overlaidcharts.OverlaidBarChartDemo1 ;
import demo.overlaidcharts.OverlaidBarChartDemo2 ;
import demo.overlaidcharts.OverlaidXYPlotDemo1 ;
import demo.overlaidcharts.OverlaidXYPlotDemo2 ;
import demo.piecharts.PieChart3DDemo1 ;
import demo.piecharts.PieChart3DDemo2 ;
import demo.piecharts.PieChart3DDemo3 ;
import demo.piecharts.PieChartDemo1 ;
import demo.piecharts.PieChartDemo2 ;
import demo.piecharts.PieChartDemo3 ;
import demo.piecharts.PieChartDemo4 ;
import demo.piecharts.PieChartDemo5 ;
import demo.piecharts.PieChartDemo7 ;
import demo.piecharts.PieChartDemo8 ;
import demo.piecharts.RingChartDemo1 ;
import demo.stackedbarcharts.PopulationChartDemo1 ;
import demo.stackedbarcharts.StackedBarChart3DDemo1 ;
import demo.stackedbarcharts.StackedBarChart3DDemo2 ;
import demo.stackedbarcharts.StackedBarChart3DDemo3 ;
import demo.stackedbarcharts.StackedBarChart3DDemo4 ;
import demo.stackedbarcharts.StackedBarChart3DDemo5 ;
import demo.stackedbarcharts.StackedBarChartDemo1 ;
import demo.stackedbarcharts.StackedBarChartDemo2 ;
import demo.stackedbarcharts.StackedBarChartDemo3 ;
import demo.stackedbarcharts.StackedBarChartDemo5 ;
import demo.stackedbarcharts.StackedBarChartDemo6 ;
import demo.stackedbarcharts.StackedBarChartDemo7 ;
import demo.statisticalcharts.BoxAndWhiskerChartDemo1 ;
import demo.statisticalcharts.BoxAndWhiskerChartDemo2 ;
import demo.statisticalcharts.HistogramDemo1 ;
import demo.statisticalcharts.HistogramDemo2 ;
import demo.statisticalcharts.MinMaxCategoryPlotDemo1 ;
import demo.statisticalcharts.NormalDistributionDemo1 ;
import demo.statisticalcharts.NormalDistributionDemo2 ;
import demo.statisticalcharts.RegressionDemo1 ;
import demo.statisticalcharts.XYErrorRendererDemo1 ;
import demo.statisticalcharts.XYErrorRendererDemo2 ;
import demo.timeseriescharts.CompareToPreviousYearDemo ;
import demo.timeseriescharts.DeviationRenderDemo1 ;
import demo.timeseriescharts.DeviationRenderDemo2 ;
import demo.timeseriescharts.DifferenceChartDemo1 ;
import demo.timeseriescharts.DifferenceChartDemo2 ;
import demo.timeseriescharts.PeriodAxisDemo1 ;
import demo.timeseriescharts.PeriodAxisDemo2 ;
import demo.timeseriescharts.PeriodAxisDemo3 ;
import demo.timeseriescharts.RelativeDateFormatDemo1 ;
import demo.timeseriescharts.TimeSeriesDemo1 ;
import demo.timeseriescharts.TimeSeriesDemo10 ;
import demo.timeseriescharts.TimeSeriesDemo11 ;
import demo.timeseriescharts.TimeSeriesDemo12 ;
import demo.timeseriescharts.TimeSeriesDemo13 ;
import demo.timeseriescharts.TimeSeriesDemo2 ;
import demo.timeseriescharts.TimeSeriesDemo3 ;
import demo.timeseriescharts.TimeSeriesDemo4 ;
import demo.timeseriescharts.TimeSeriesDemo5 ;
import demo.timeseriescharts.TimeSeriesDemo6 ;
import demo.timeseriescharts.TimeSeriesDemo7 ;
import demo.timeseriescharts.TimeSeriesDemo8 ;
import demo.timeseriescharts.TimeSeriesDemo9 ;
import demo.xycharts.Function2DDemo1 ;
import demo.xycharts.LogAxisDemo1 ;
import demo.xycharts.ScatterPlotDemo1 ;
import demo.xycharts.ScatterPlotDemo2 ;
import demo.xycharts.ScatterPlotDemo3 ;
import demo.xycharts.ScatterPlotDemo4 ;
import demo.xycharts.VectorDemo1 ;
import demo.xycharts.XYBlockChartDemo1 ;
import demo.xycharts.XYBlockChartDemo2 ;
import demo.xycharts.XYBlockChartDemo3 ;
import demo.xycharts.XYLineAndShapeRenderDemo1 ;
import demo.xycharts.XYLineAndShapeRenderDemo2 ;
import demo.xycharts.XYSeriesDemo1 ;
import demo.xycharts.XYSeriesDemo2 ;
import demo.xycharts.XYSeriesDemo3 ;
import demo.xycharts.XYShapeRenderDemo1 ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DemosTree extends MouseAdapter {
  private final boolean addNode = true ;

  private JTree tree ;

  public DemosTree() {
    init() ;
    expandTree("Miscellaneous") ;
  }

  public JTree getTree() {
    return tree ;
  }

  private void init() {
    DefaultMutableTreeNode root = new DefaultMutableTreeNode("root") ;
    tree = new JTree(root) ;
    tree.putClientProperty("JTree.lineStyle", "Angled") ;
    tree.addMouseListener(this) ;

    createAreaChartNodes(root) ;
    createBarChartNodes(root) ;
    createStackedBarChartNodes(root) ;
    createCombinedAxisChart(root) ;
    createFinancialChart(root) ;
    createGanttChart(root) ;
    createLineChart(root) ;
//    createMeterChart(root) ;
    createMultipleAxisCharts(root) ;
    createOverlaidCharts(root) ;
    createPieCharts(root) ;
    createStatisticalCharts(root) ;
    createTimeSeriesCharts(root) ;
    createXYChartNodes(root) ;
    createMiscellaneousCharts(root) ;

    //δ֤
//    createOtherCharts(root) ;
  }

  /**
   * ͼβ
   * @param parentNode DefaultMutableTreeNode
   */
//  private void createShapeNodes(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode shapesNode = new DefaultMutableTreeNode("shapes") ;
//    parentNode.add(shapesNode) ;
//
//    addNode(shapesNode, RectangleTextChartShapePanel1.class) ;
//    addNode(shapesNode, RectangleTextChartShapePanel2.class) ;
//    addNode(shapesNode, RectangleTextChartShapePanel3.class) ;
//    addNode(shapesNode, ParallelepipedChartShapePanel.class) ;
//    addNode(shapesNode, RectangleImageChartShapePanel.class) ;
//    addNode(shapesNode, LineChartShapePanel.class) ;
//    addNode(shapesNode, DualBreakLineChartShapePanel.class) ;
//    addNode(shapesNode, GeneralPathChartShapePanel.class) ;
//    addNode(shapesNode, IShapedChartShapePanel.class) ;
//    addNode(shapesNode, StatisticalBarChartShapePanel.class) ;
//    addNode(shapesNode, StatisticalLineChartShapePanel.class) ;
//    addNode(shapesNode, BoxAndWhiskerChartShapePanel.class) ;
//    addNode(shapesNode, CylinderTextChartShapePanel.class) ;
//    addNode(shapesNode, GranttChartShapePanel.class) ;
//    addNode(shapesNode, LineAndShapeChartShapePanel.class) ;
//    addNode(shapesNode, PathAppendPanel.class) ;
//    addNode(shapesNode, TooltipShapeTestPanel.class) ;
//    addNode(shapesNode, StockChartShapePanel.class) ;
//    addNode(shapesNode, HighLowChartShapePanel.class) ;
//    addNode(shapesNode, LineToRectanglePanel.class) ;
//    addNode(shapesNode, TextAndPointChartShapePanel.class) ;
//    addNode(shapesNode, ArcShapeTestPanel.class) ;
//    addNode(shapesNode, MeterArcShapePanel.class) ;
//    addNode(shapesNode, PaintScaleLegendShapePanel.class) ;
//    addNode(shapesNode, SectorChartShapePanel.class) ;
//    addNode(shapesNode, Sector3DChartShapePanel.class) ;
//    addNode(shapesNode, PieOutsideLabelChartShapePanel.class) ;
//    addNode(shapesNode, RingChartShapePanel.class) ;
//    addNode(shapesNode, ErrorCrossChartShapePanel.class) ;
//    addNode(shapesNode, EllipseTextChartShapePanel.class) ;
//    addNode(shapesNode, DblHeadMatchstickChartShapePanel.class) ;
//    addNode(shapesNode, MinMaxChartShapePanel.class) ;
//  }

  private void createAreaChartNodes(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Area charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, AreaChartDemo1.class, true) ;
    addNode(chartNodes, StackedAreaChartDemo1.class, true) ;
    addNode(chartNodes, StackedXYAreaChartDemo1.class, true) ;
    addNode(chartNodes, StackedXYAreaChartDemo2.class, true) ;
    addNode(chartNodes, XYAreaChartDemo1.class, true) ;
    addNode(chartNodes, XYAreaChartDemo2.class, true) ;
    addNode(chartNodes, XYAreaRenderer2Demo1.class, true) ;
    addNode(chartNodes, XYStepAreaRendererDemo1.class, true) ;
  }

  private void createBarChartNodes(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Bar Charts") ;
    parentNode.add(chartNodes) ;

    createCategoryPlotChartNodes(chartNodes) ;
    createXYPlotChartNodes(chartNodes) ;
  }

  private void createCategoryPlotChartNodes(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("CategoryPlot") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, BarChartDemo1.class, true) ;
    addNode(chartNodes, BarChartDemo2.class, true) ;
    addNode(chartNodes, BarChartDemo3.class, true) ;
    addNode(chartNodes, BarChartDemo4.class, true) ;
    addNode(chartNodes, BarChartDemo5.class, true) ;
    addNode(chartNodes, BarChartDemo6.class, true) ;
    addNode(chartNodes, BarChartDemo7.class, true) ;
    addNode(chartNodes, BarChartDemo8.class, true) ;
    addNode(chartNodes, BarChartDemo9.class, true) ;
    addNode(chartNodes, BarChartDemo10.class, true) ;
    addNode(chartNodes, BarChartDemo11.class, true) ;
    addNode(chartNodes, BarChart3DDemo1.class, true) ;
    addNode(chartNodes, BarChart3DDemo2.class, true) ;
    addNode(chartNodes, BarChart3DDemo3.class, true) ;
    addNode(chartNodes, BarChart3DDemo4.class, true) ;
    addNode(chartNodes, CylinderChartDemo1.class, true) ;
    addNode(chartNodes, CylinderChartDemo2.class, true) ;
    addNode(chartNodes, IntervalBarChartDemo1.class, true) ;
    addNode(chartNodes, LayeredBarChartDemo1.class, true) ;
    addNode(chartNodes, LayeredBarChartDemo2.class, true) ;
    addNode(chartNodes, SlidingCategoryDatasetDemo1.class, true) ;
    addNode(chartNodes, SlidingCategoryDatasetDemo2.class, true) ;
    addNode(chartNodes, StatisticalBarChartDemo1.class, true) ;
    addNode(chartNodes, SurveyResultsDemo1.class, true) ;
    addNode(chartNodes, SurveyResultsDemo2.class, true) ;
    addNode(chartNodes, SurveyResultsDemo3.class, true) ;
    addNode(chartNodes, WaterfallChartDemo1.class, true) ;
  }

  private void createXYPlotChartNodes(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("XYPlot") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, XYBarChartDemo1.class, true) ;
    addNode(chartNodes, XYBarChartDemo2.class, true) ;
    addNode(chartNodes, XYBarChartDemo3.class, true) ;
    addNode(chartNodes, XYBarChartDemo4.class, true) ;
    addNode(chartNodes, XYBarChartDemo5.class, true) ;
    addNode(chartNodes, XYBarChartDemo6.class, true) ;
    addNode(chartNodes, XYBarChartDemo7.class, true) ;
    addNode(chartNodes, ClusteredXYBarRendererDemo1.class, true) ;
    addNode(chartNodes, StackedXYBarChartDemo1.class, true) ;
    addNode(chartNodes, StackedXYBarChartDemo2.class, true) ;
    addNode(chartNodes, StackedXYBarChartDemo3.class, true) ;
    addNode(chartNodes, RelativeDateFormatDemo1.class, true) ;
    addNode(chartNodes, RelativeDateFormatDemo2.class, true) ;
  }

  private void createStackedBarChartNodes(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Bar Charts - Stacked") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, PopulationChartDemo1.class, true) ;
    addNode(chartNodes, StackedBarChartDemo1.class, true) ;
    addNode(chartNodes, StackedBarChartDemo2.class, true) ;
    addNode(chartNodes, StackedBarChartDemo3.class, true) ;
    addNode(chartNodes, StackedBarChartDemo4.class, true) ;
    addNode(chartNodes, StackedBarChartDemo5.class, true) ;
    addNode(chartNodes, StackedBarChartDemo6.class, true) ;
    addNode(chartNodes, StackedBarChartDemo7.class, true) ;
    addNode(chartNodes, StackedBarChart3DDemo1.class, true) ;
    addNode(chartNodes, StackedBarChart3DDemo2.class, true) ;
    addNode(chartNodes, StackedBarChart3DDemo3.class, true) ;
    addNode(chartNodes, StackedBarChart3DDemo4.class, true) ;
    addNode(chartNodes, StackedBarChart3DDemo5.class, true) ;
  }

  private void createXYChartNodes(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("XY Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, ScatterPlotDemo1.class, true) ;
    addNode(chartNodes, ScatterPlotDemo2.class, true) ;
    addNode(chartNodes, ScatterPlotDemo3.class, true) ;
    addNode(chartNodes, LogAxisDemo1.class, true) ;
    addNode(chartNodes, Function2DDemo1.class, true) ;

    addNode(chartNodes, XYBlockChartDemo1.class, true) ;
    addNode(chartNodes, XYBlockChartDemo2.class, true) ;
    addNode(chartNodes, XYBlockChartDemo3.class, true) ;
    addNode(chartNodes, XYLineAndShapeRenderDemo1.class, true) ;
    addNode(chartNodes, XYLineAndShapeRenderDemo2.class, true) ;

    addNode(chartNodes, XYSeriesDemo1.class, true) ;
    addNode(chartNodes, XYSeriesDemo2.class, true) ;
    addNode(chartNodes, XYSeriesDemo3.class, true) ;
    addNode(chartNodes, XYShapeRenderDemo1.class, true) ;
    addNode(chartNodes, VectorDemo1.class, true) ;
  }

  private void createCombinedAxisChart(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Combined Axis Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, CombinedCategoryPlotDemo1.class, true) ;
    addNode(chartNodes, CombinedCategoryPlotDemo2.class, true) ;
    addNode(chartNodes, CombinedTimeSeriesDemo1.class, true) ;
    addNode(chartNodes, CombinedXYPlotDemo1.class, true) ;
    addNode(chartNodes, CombinedXYPlotDemo2.class, true) ;
    addNode(chartNodes, CombinedXYPlotDemo3.class, true) ;
    addNode(chartNodes, CombinedXYPlotDemo4.class, true) ;
  }

  private void createFinancialChart(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Financial Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, CandlestickChartDemo1.class, true) ;
    addNode(chartNodes, HighLowChartDemo1.class, true) ;
    addNode(chartNodes, HighLowChartDemo2.class, true) ;
    addNode(chartNodes, HighLowChartDemo3.class, true) ;
    addNode(chartNodes, MovingAverageDemo1.class, true) ;
    addNode(chartNodes, PriceVolumeDemo1.class, true) ;
    addNode(chartNodes, PriceVolumeDemo2.class, true) ;
//    addNode(chartNodes, YieldCurveChartPanel__NotImplemented.class) ;
  }

  private void createGanttChart(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Gantt Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, GanttDemo1.class, true) ;
    addNode(chartNodes, GanttDemo2.class, true) ;
    addNode(chartNodes, SlidingGanttDatasetDemo1.class, true) ;
    addNode(chartNodes, XYTaskDatasetDemo1.class, true) ;
    addNode(chartNodes, XYTaskDatasetDemo2.class, true) ;
  }

  private void createLineChart(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Line Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, AnnotationDemo1.class, true) ;
    addNode(chartNodes, LineChartDemo1.class, true) ;
    addNode(chartNodes, LineChartDemo2.class, true) ;
    addNode(chartNodes, LineChartDemo3.class, true) ;
    addNode(chartNodes, LineChartDemo4.class, true) ;
    addNode(chartNodes, LineChartDemo5.class, true) ;
    addNode(chartNodes, LineChartDemo6.class, true) ;
    addNode(chartNodes, LineChartDemo7.class, true) ;
    addNode(chartNodes, LineChartDemo8.class, true) ;
    addNode(chartNodes, LineChart3DDemo1.class, true) ;
    addNode(chartNodes, StatisticalLineChartDemo1.class, true) ;
    addNode(chartNodes, XYSplineRendererDemo1.class, true) ;
    addNode(chartNodes, XYStepRendererDemo1.class, true) ;
    addNode(chartNodes, XYStepRendererDemo2.class, true) ;
  }

//  private void createMeterChart(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Meter Charts##") ;
//    parentNode.add(chartNodes) ;
//
//    addNode(chartNodes, MeterChartPanel1.class) ;
//    addNode(chartNodes, MeterChartPanel2.class) ;
//    addNode(chartNodes, MeterChartPanel3.class) ;
//    addNode(chartNodes, MeterChartPanel4.class) ;
//    addNode(chartNodes, MeterChartPanel5.class) ;
//  }

  private void createMultipleAxisCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Multiple Axis Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, DualAxisDemo1.class, true) ;
    addNode(chartNodes, DualAxisDemo2.class, true) ;
    addNode(chartNodes, DualAxisDemo3.class, true) ;
    addNode(chartNodes, DualAxisDemo4.class, true) ;
    addNode(chartNodes, DualAxisDemo5.class, true) ;
    addNode(chartNodes, MultipleAxisDemo1.class, true) ;
    addNode(chartNodes, MultipleAxisDemo2.class, true) ;
    addNode(chartNodes, MultipleAxisDemo3.class, true) ;
    addNode(chartNodes, ParetoChartDemo1.class, true) ;
  }

  private void createOverlaidCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Overlaid Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, OverlaidBarChartDemo1.class) ;
    addNode(chartNodes, OverlaidBarChartDemo2.class) ;
    addNode(chartNodes, OverlaidXYPlotDemo1.class) ;
    addNode(chartNodes, OverlaidXYPlotDemo2.class) ;
  }

  private void createPieCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Pie Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, PieChartDemo1.class, true) ;
    addNode(chartNodes, PieChartDemo2.class, true) ;
    addNode(chartNodes, PieChartDemo3.class, true) ;
    addNode(chartNodes, PieChartDemo4.class, true) ;
    addNode(chartNodes, PieChartDemo5.class, true) ;
    addNode(chartNodes, PieChartDemo7.class, true) ;
    addNode(chartNodes, PieChartDemo8.class, true) ;
    addNode(chartNodes, PieChart3DDemo1.class, true) ;
    addNode(chartNodes, PieChart3DDemo2.class, true) ;
    addNode(chartNodes, PieChart3DDemo3.class, true) ;
    addNode(chartNodes, RingChartDemo1.class, true) ;
  }

  private void createStatisticalCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Statistical Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, BoxAndWhiskerChartDemo1.class, true) ;
    addNode(chartNodes, BoxAndWhiskerChartDemo2.class, true) ;
    addNode(chartNodes, HistogramDemo1.class, true) ;
    addNode(chartNodes, HistogramDemo2.class, true) ;
    addNode(chartNodes, MinMaxCategoryPlotDemo1.class, true) ;
    addNode(chartNodes, NormalDistributionDemo1.class, true) ;
    addNode(chartNodes, NormalDistributionDemo2.class, true) ;
    addNode(chartNodes, RegressionDemo1.class, true) ;
    addNode(chartNodes, ScatterPlotDemo1.class, true) ;
    addNode(chartNodes, ScatterPlotDemo2.class, true) ;
    addNode(chartNodes, ScatterPlotDemo3.class, true) ;
    addNode(chartNodes, ScatterPlotDemo4.class, true) ;
    addNode(chartNodes, XYErrorRendererDemo1.class, true) ;
    addNode(chartNodes, XYErrorRendererDemo2.class, true) ;
  }

  private void createTimeSeriesCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Time Series Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, TimeSeriesDemo1.class, true) ;
    addNode(chartNodes, TimeSeriesDemo2.class, true) ;
    addNode(chartNodes, TimeSeriesDemo3.class, true) ;
    addNode(chartNodes, TimeSeriesDemo4.class, true) ;
    addNode(chartNodes, TimeSeriesDemo5.class, true) ;
    addNode(chartNodes, TimeSeriesDemo6.class, true) ;
    addNode(chartNodes, TimeSeriesDemo7.class, true) ;
    addNode(chartNodes, TimeSeriesDemo8.class, true) ;
    addNode(chartNodes, TimeSeriesDemo9.class, true) ;
    addNode(chartNodes, TimeSeriesDemo10.class, true) ;
    addNode(chartNodes, TimeSeriesDemo11.class, true) ;
    addNode(chartNodes, TimeSeriesDemo12.class, true) ;
    addNode(chartNodes, TimeSeriesDemo13.class, true) ;
    addNode(chartNodes, PeriodAxisDemo1.class, true) ;
    addNode(chartNodes, PeriodAxisDemo2.class, true) ;
    addNode(chartNodes, PeriodAxisDemo3.class, true) ;
    addNode(chartNodes, RelativeDateFormatDemo1.class, true) ;
    addNode(chartNodes, DeviationRenderDemo1.class, true) ;
    addNode(chartNodes, DeviationRenderDemo2.class, true) ;
    addNode(chartNodes, DifferenceChartDemo1.class, true) ;
    addNode(chartNodes, DifferenceChartDemo2.class, true) ;
    addNode(chartNodes, CompareToPreviousYearDemo.class, true) ;

  }

  private void createMiscellaneousCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Miscellaneous") ;
    parentNode.add(chartNodes) ;

    createAnnotationsCharts(chartNodes) ;
    createCrosshairCharts(chartNodes) ;
    createDynamicChartsCharts(chartNodes) ;
    createItemLabelsCharts(chartNodes) ;
    createLegendWrapperCharts(chartNodes) ;
    createMarkerCharts(chartNodes) ;
    createOrientationCharts(chartNodes) ;

    addNode(chartNodes, AxisOffsetsDemo1.class, true) ;
    addNode(chartNodes, BubbleChartDemo1.class, true) ;
    addNode(chartNodes, BubbleChartDemo2.class, true) ;
    addNode(chartNodes, CategoryLabelPositionsDemo1.class, true) ;
    addNode(chartNodes, CategoryStepChartDemo1.class, true) ;
    addNode(chartNodes, CompassFormatDemo1.class, true) ;
    addNode(chartNodes, EventFrequencyDemo1.class, true) ;
    addNode(chartNodes, GradientPaintTransformerDemo1.class, true) ;
    addNode(chartNodes, GridBandDemo1.class, true) ;
    addNode(chartNodes, HideSeriesDemo1.class, true) ;
    addNode(chartNodes, HideSeriesDemo2.class, true) ;
    addNode(chartNodes, HideSeriesDemo3.class, true) ;
    addNode(chartNodes, MultipleDatasetDemo1.class, true) ;
    addNode(chartNodes, PolarChartDemo1.class, true) ;
    addNode(chartNodes, SpiderWebChartDemo1.class, true) ;
    addNode(chartNodes, SymbolAxisDemo1.class, true) ;
    addNode(chartNodes, ThumbnailDemo1.class, true) ;
    addNode(chartNodes, TranslateDemo1.class, true) ;
    addNode(chartNodes, WindChartDemo1.class, true) ;
    addNode(chartNodes, YIntervalChartDemo1.class, true) ;
    addNode(chartNodes, YIntervalChartDemo2.class, true) ;
  }

  private void createAnnotationsCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Annotations") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, AnnotationDemo1.class, true) ;
    addNode(chartNodes, AnnotationDemo2.class, true) ;
    addNode(chartNodes, CategoryPointerAnnotationDemo1.class, true) ;
    addNode(chartNodes, XYBoxAnnotationDemo1.class, true) ;
    addNode(chartNodes, XYPolygonAnnotationDemo1.class, true) ;
    addNode(chartNodes, XYTitleAnnotationDemo1.class, true) ;
  }

  private void createOrientationCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Orientation") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, PlotOrientationDemo1.class, true) ;
    addNode(chartNodes, PlotOrientationDemo2.class, true) ;
  }

  private void createDynamicChartsCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Dynamic Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, DynamicDataDemo1.class, true) ;
    addNode(chartNodes, DynamicDataDemo2.class, true) ;
    addNode(chartNodes, DynamicDataDemo3.class, true) ;
    addNode(chartNodes, MouseOverDemo1.class, true) ;
  }

  private void createItemLabelsCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Item Labels") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, ItemLabelDemo1.class, true) ;
    addNode(chartNodes, ItemLabelDemo2.class, true) ;
    addNode(chartNodes, ItemLabelDemo3.class, true) ;
    addNode(chartNodes, ItemLabelDemo4.class, true) ;
    addNode(chartNodes, ItemLabelDemo5.class, true) ;
  }

  private void createLegendWrapperCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Legends") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, LegendWrapperDemo1.class, true) ;
  }

  private void createMarkerCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Markers") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, CategoryMarkerDemo1.class, true) ;
    addNode(chartNodes, CategoryMarkerDemo2.class, true) ;
    addNode(chartNodes, MarkerDemo1.class, true) ;
    addNode(chartNodes, MarkerDemo2.class, true) ;
  }

  private void createCrosshairCharts(DefaultMutableTreeNode parentNode) {
    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Crosshair Charts") ;
    parentNode.add(chartNodes) ;

    addNode(chartNodes, CrosshairDemo1.class, true) ;
    addNode(chartNodes, CrosshairDemo2.class, true) ;
    addNode(chartNodes, CrosshairDemo3.class, true) ;
    addNode(chartNodes, CrosshairDemo4.class, true) ;
  }

//  private void createOtherCharts(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Others") ;
//    parentNode.add(chartNodes) ;
//
//    createShapeNodes(chartNodes) ;
//    createOtherXYCharts(chartNodes) ;
//    createOtherNoAxisCharts(chartNodes) ;
//
//    createAxisChartNodes(chartNodes) ;
//    createCategoryChartNodes(chartNodes) ;
//    createStackedXYChart(chartNodes) ;
//    createAnnotationChart(chartNodes) ;
//    createXYCharts(chartNodes) ;
//  }

//  private void createOtherXYCharts(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Other XY") ;
//    parentNode.add(chartNodes) ;
//
//    addNode(chartNodes, StockChartPanel2.class) ;
//    addNode(chartNodes, PriceVolumeChartPanel1.class) ;
//    addNode(chartNodes, Line3DChartPanel1.class) ;
//
//    addNode(chartNodes, HistogramChartPanel3.class) ;
//    addNode(chartNodes, XYErrorChartPanel3.class) ;
//
//    addNode(chartNodes, XYBlockChartPanel1.class) ;
//    addNode(chartNodes, XYBlockChartPanel2.class) ;
//    addNode(chartNodes, XYBlockChartPanel3.class) ;
//
//    addNode(chartNodes, XYLineAndShapeChartPanel1.class) ;
//    addNode(chartNodes, XYLineAndShapeChartPanel2.class) ;
//    addNode(chartNodes, XYLineAndShapeChartPanel3.class) ;
//    addNode(chartNodes, XYLineAndShapeChartPanel4.class) ;
//    addNode(chartNodes, XYLineAndShapeChartPanel5.class) ;
//    addNode(chartNodes, XYLineAndShapeChartPanel6.class) ;
//
//    addNode(chartNodes, XYStepLineChartPanel1.class) ;
//    addNode(chartNodes, XYStepLineChartPanel2.class) ;
//
//    addNode(chartNodes, IntervalXYNumberBar2DChartPanel1.class) ;
//    addNode(chartNodes, IntervalXYNumberBar2DChartPanel2.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanel1.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanel2.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanelYear.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanelMonth.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanelDay.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanelHour.class) ;
//    addNode(chartNodes, IntervalXNumberYBaseBar2DChartPanelMinute.class) ;
//    addNode(chartNodes, IntervalXNumberBar2DChartPanelDay.class) ;
//
//    addNode(chartNodes, ClusteredXYNumberBar2DChartPanel1.class) ;
//    addNode(chartNodes, ClusteredXYNumberBar2DChartPanel2.class) ;
//
//    addNode(chartNodes, GrowthVerticalChart.class) ;
//    addNode(chartNodes, GrowthHorizontalChart.class) ;
//  }

//  private void createOtherNoAxisCharts(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Other No Axis") ;
//    parentNode.add(chartNodes) ;
//
//    addNode(chartNodes, PieChartPanel3.class) ;
//    addNode(chartNodes, Pie3DChartPanel1.class) ;
//    addNode(chartNodes, Pie3DChartPanel2.class) ;
//    addNode(chartNodes, RingChartPanel2.class) ;
//    addNode(chartNodes, RingChartPanel3.class) ;
//  }

//  private void createAxisChartNodes(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("axis") ;
//    parentNode.add(chartNodes) ;
//
//    addNode(chartNodes, CategoryAxisPanel.class) ;
//    addNode(chartNodes, CategoryAxis3DPanel.class) ;
//    addNode(chartNodes, NumberValueAxisPanel.class) ;
//    addNode(chartNodes, MultipleAxisPanel.class) ;
//  }

//  private void createCategoryChartNodes(DefaultMutableTreeNode parentNode) {
//     DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("category charts") ;
//     parentNode.add(chartNodes) ;
//
//     addNode(chartNodes, CategoryBar2DChartPanel1.class) ;
//     addNode(chartNodes, CategoryBar2DChartPanel2.class) ;
//     addNode(chartNodes, CategoryBar2DChartPanel3.class) ;
//     addNode(chartNodes, CategoryBar3DChartPanel1.class) ;
//     addNode(chartNodes, CategoryBar3DChartPanel2.class) ;
//     addNode(chartNodes, CylinderChartPanel.class) ;
//     addNode(chartNodes, IntervalBarChartPanel.class) ;
//     addNode(chartNodes, LayeredBarChartPanel.class) ;
//     addNode(chartNodes, StackedBarChartPanel1.class) ;
//     addNode(chartNodes, StackedBarChartPanel2.class) ;
//     addNode(chartNodes, StatisticalBarChartPanel1.class) ;
//     addNode(chartNodes, StatisticalBarChartPanel2.class) ;
//     addNode(chartNodes, StatisticalBarChartPanel3.class) ;
//     addNode(chartNodes, StatisticalBarChartPanel4.class) ;
//     addNode(chartNodes, StatisticalBarChartPanel5.class) ;
//     addNode(chartNodes, StatisticalBarChartPanelWithLabel.class) ;
//     addNode(chartNodes, WaterfallBarChartPanel1.class) ;
//     addNode(chartNodes, WaterfallBarChartPanel2.class) ;
//     addNode(chartNodes, WaterfallBarChartPanel3.class) ;
//     addNode(chartNodes, WaterfallBarChartPanel4.class) ;
//     addNode(chartNodes, AreaChartPanel1.class) ;
//     addNode(chartNodes, AreaChartPanel2.class) ;
//     addNode(chartNodes, BoxAndWhiskerChartPanel1.class) ;
//     addNode(chartNodes, CategoryStepChartPanel1.class) ;
//     addNode(chartNodes, GranttChartPanel1.class) ;
//     addNode(chartNodes, GranttChartPanel2.class) ;
//     addNode(chartNodes, GranttChartPanel3.class) ;
//     addNode(chartNodes, GranttChartPanel4.class) ;
//     addNode(chartNodes, GranttChartPanel5.class) ;
//     addNode(chartNodes, GranttChartPanel6.class) ;
//     addNode(chartNodes, GranttChartPanel7.class) ;
//     addNode(chartNodes, GranttChartPanel8.class) ;
//     addNode(chartNodes, GroupStackedBarChartPanel1.class) ;
//     addNode(chartNodes, GroupStackedBarChartPanel2.class) ;
//     addNode(chartNodes, GroupStackedBarChartPanel3.class) ;
//     addNode(chartNodes, GroupStackedBarChartPanel4.class) ;
//     addNode(chartNodes, OverlaidBarChartpPanel1.class) ;
//     addNode(chartNodes, LevelChartPanel1.class) ;
//     addNode(chartNodes, LevelChartPanel2.class) ;
//     addNode(chartNodes, CategoryLineAndShapeChartPanel1.class) ;
//     addNode(chartNodes, CategoryLineAndShapeChartPanel2.class) ;
//     addNode(chartNodes, CategoryLineAndShapeChartPanel4.class) ;
//
//     addNode(chartNodes, SymbolCategoryLineAndShapeChartPanel1.class) ;
//     addNode(chartNodes, SymbolCategoryLineAndShapeChartPanel2.class) ;
//     addNode(chartNodes, SymbolCategoryLineAndShapeChartPanel3.class) ;
//     addNode(chartNodes, SymbolCategoryLineAndShapeChartPanel4.class) ;
//     addNode(chartNodes, SymbolXYLineAndShapeChartPanel1.class) ;
//     addNode(chartNodes, SymbolXYLineAndShapeChartPanel2.class) ;
//     addNode(chartNodes, SymbolXYLineAndShapeChartPanel3.class) ;
//     addNode(chartNodes, SymbolXYLineAndShapeChartPanel4.class) ;
//
//     addNode(chartNodes, StatisticalLineChartPanel1.class) ;
//     addNode(chartNodes, StatisticalLineChartPanelWithLabelPanel.class) ;
//   }

//  private void createStackedXYChart(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Stack area charts") ;
//    parentNode.add(chartNodes) ;
//
//    addNode(chartNodes, StackedXYBarChartPanel1.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel2.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel3.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel4.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel5.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel6.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel7.class) ;
//    addNode(chartNodes, StackedXYBarChartPanel8.class) ;
//
//    addNode(chartNodes, StackedXYAreaChartPanel1.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel2.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel3.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel4.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel5.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel6.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel7.class) ;
//    addNode(chartNodes, StackedXYAreaChartPanel8.class) ;
//
//    addNode(chartNodes, XYAreaChartPanel1.class) ;
//    addNode(chartNodes, XYAreaChartPanel2.class) ;
//
//    addNode(chartNodes, StackedXYStepAreaChartPanel1.class) ;
//    addNode(chartNodes, StackedXYStepAreaChartPanel2.class) ;
//    addNode(chartNodes, StackedXYStepAreaChartPanel3.class) ;
//    addNode(chartNodes, StackedXYStepAreaChartPanel4.class) ;
//    addNode(chartNodes, StackedXYStepAreaChartPanel5.class) ;
//  }

//  private void createAnnotationChart(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("Annotation Charts") ;
//    parentNode.add(chartNodes) ;
//
//    // category annotations
//    addNode(chartNodes, CategoryTextAnnotationTest1.class) ;
//    addNode(chartNodes, CategoryTextAnnotationTest2.class) ;
//    addNode(chartNodes, CategoryTextAnnotationTestGroup1.class) ;
//    addNode(chartNodes, CategoryTextAnnotationTestGroup2.class) ;
//    addNode(chartNodes, CategoryLineAnnotationTest1.class) ;
//    addNode(chartNodes, CategoryLineAnnotationTest2.class) ;
//    addNode(chartNodes, CategoryAndPointerAnnotationTest1.class) ;
//    addNode(chartNodes, CategoryAndPointerAnnotationTest2.class) ;
//
//    // xy annotations
//    addNode(chartNodes, XYTextAnnotationTest1.class) ;
//    addNode(chartNodes, XYTextAnnotationTest2.class) ;
//    addNode(chartNodes, XYLineAnnotationTest1.class) ;
//    addNode(chartNodes, XYLineAnnotationTest2.class) ;
//    addNode(chartNodes, XYPointerAnnotationTest1.class) ;
//    addNode(chartNodes, XYPointerAnnotationTest2.class) ;
//    addNode(chartNodes, XYShapeAnnotationTest1.class) ;
//    addNode(chartNodes, XYShapeAnnotationTest2.class) ;
//    addNode(chartNodes, XYPolygonAnnotationTest1.class) ;
//    addNode(chartNodes, XYPolygonAnnotationTest2.class) ;
//    addNode(chartNodes, XYImageAnnotationTest1.class) ;
//    addNode(chartNodes, XYImageAnnotationTest2.class) ;
//  }

//  private void createXYCharts(DefaultMutableTreeNode parentNode) {
//    DefaultMutableTreeNode chartNodes = new DefaultMutableTreeNode("XY Charts2") ;
//    parentNode.add(chartNodes) ;
//
//    addNode(chartNodes, ScatterDemo1.class) ;
//    addNode(chartNodes, DotDemo1.class) ;
//    addNode(chartNodes, DotDemo2.class) ;
//  }

  private void addNode(DefaultMutableTreeNode parentNode, Class c) {
    addNode(parentNode, c, this.addNode) ;
  }

  private void addNode(DefaultMutableTreeNode parentNode, Class c, boolean add) {
    if (add) {
      DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(new TreeNodeBean(c)) ;
      parentNode.add(childNode) ;
    }
  }

  private void expandTree(String name) {
    DefaultMutableTreeNode root = (DefaultMutableTreeNode) tree.getModel().getRoot() ;
    Enumeration children = root.breadthFirstEnumeration() ;
    while (children.hasMoreElements()) {
      DefaultMutableTreeNode child = (DefaultMutableTreeNode) children.nextElement() ;
      if (child.toString().equals(name)) {
        tree.expandPath(new TreePath(child.getPath())) ;
      }
//      if (child.getDepth() == 1) {
//        tree.expandPath(new TreePath(child.getPath())) ;
//      }
    }
  }

  public void mouseClicked(MouseEvent e) {
    Point p = e.getPoint() ;
    TreePath treePath = tree.getPathForLocation(p.x, p.y) ;
    if (treePath == null) {
      return ;
    }
    DefaultMutableTreeNode node = (DefaultMutableTreeNode) treePath.getLastPathComponent() ;
    Object obj = node.getUserObject() ;
    if (obj != null && obj instanceof TreeNodeBean) {
      TreeNodeBean treeNode = (TreeNodeBean) obj ;
      JPanel panel = null ;
      try {
        panel = (JPanel) (treeNode.cls.newInstance()) ;
      } catch (Exception ex) {
        ex.printStackTrace() ;
      }
      DemosGallery.getInstance().setRightComponent(panel) ;
    } else {
      DemosGallery.getInstance().setRightComponent(new JPanel()) ;
    }
  }

  private class TreeNodeBean {
    private Class cls ;

    TreeNodeBean(Class c) {
      this.cls = c ;
    }

    public String toString() {
      String name = cls.getName() ;
      return name.substring(name.lastIndexOf(".") + 1) ;
    }

  }
}
