package com.ijchart.xychart.chartinfo.draw ;

import com.ijchart.xychart.chartinfo.ChartShapeCollection ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ӿ{@link IChangeChartShape}.</zh>
 * <en>The adapter for class {@link IChangeChartShape}.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ChangeChartShapeAdapter implements IChangeChartShape {
  /**
   * <zh>{@link ChartShapeCollection#draw(Graphics2D)}֮ǰ.</zh>
   * <en>Call this method before {@link ChartShapeCollection#draw(Graphics2D)}.</en>
   *
   * @param chartShapes ChartShapeCollection <zh>(Ϊnull).</zh>
   * <en>(null not permitted).</en>
   */
  public void beforeDraw(ChartShapeCollection chartShapes) {}

  /**
   * <zh>{@link ChartShapeCollection#draw(Graphics2D)}֮.</zh>
   * <en>Call this method after {@link ChartShapeCollection#draw(Graphics2D)}.</en>
   *
   * @param chartShapes ChartShapeCollection <zh>(Ϊnull).</zh>
   * <en>(null not permitted).</en>
   */
  public void afterDraw(ChartShapeCollection chartShapes) {}
}
