package com.ijchart.xychart.listener ;

import java.util.EventListener ;

import com.ijchart.xychart.event.DatasetChangeEvent ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ӿڱҪյݼ仯ʵ.</zh>
 * <en>The interface that must be supported by classes that wish to receive notification of changes
 * to a dataset.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IDatasetChangeListener extends EventListener {
  /**
   * <zh>յݼ仯֪ͨ.</zh>
   * <en>Receives notification of an dataset change event.</en>
   *
   * @param event DatasetChangeEvent <zh>ݼ仯Ķ</zh>
   * <en>Information about the event.</en>
   */
  void datasetChanged(DatasetChangeEvent event) ;

}
